//
// A Multimedia Traffic Simulation
//
// 
// (c) Copyright ensi, 1997.
//
// collector class - source file

#include "collector.h"

c_collector::c_collector()
{

  safe_images = 0;
  
  fd_rt.open("rt.sim");
  if (!fd_rt)
    {
      cerr << "cannot open rt.sim, aborting.." << endl;
      exit(ERR_FILE_SYSTEM);
    }

  fd_misc.open("misc.sim");
  if (!fd_misc)
    {
      cerr << "cannot open misc.sim, aborting.." << endl;
      exit(ERR_FILE_SYSTEM);
    }
    
  fd_sr.open("sr.sim");
  if (!fd_sr)
    {
      cerr << "cannot open sr.sim, aborting.." << endl;
      exit(ERR_FILE_SYSTEM);
    }
}


int c_collector::inc_safe_images()
{
  safe_images++;
  return OK;
}


int c_collector::get_safe_images()
{
  return safe_images;
}


int c_collector::register_rt(double rt, double date, int i_id)
{
  fd_rt << date << "\t" << rt << "\t" << i_id << endl;
  return OK;
}


int c_collector::register_setting(char *p_name, int p_val)
{
  fd_misc << p_name << "\t\t" << p_val << endl;
  return OK;
}


int c_collector::register_success_rate(double sr, double date)
{
  fd_sr << date << "\t" << sr << endl;
  return OK;
}


c_collector::~c_collector()
{
  fd_rt.close();
  fd_misc.close();
}
