//
// A Multimedia Traffic Simulation
//
// 
// (c) Copyright ensi, 1997.
//
// router class - header file
//

#ifndef __ROUTER_H
#define __ROUTER_H

#include "collector.h"
#include "time_line.h"
#include "packet_gen.h"

double current_date = 0.0; //the current date
double sim_duration = 0.0; //duration of simulation

class c_router : c_time_line
{
  public:
    c_packet_generator *packet_gen;
    c_collector collector;
    c_time_line *time_line;
    double last_departure;
    double current_date, simulation_date;
    int queue_capacity;
    int queue_size;

  private:
    int net_capacity;           // in bps

  public:
    c_router ();
    c_router(int net_cap, double sd, int queue_cap);
    int get_net_capacity();
    int init_simulation ();
    virtual int start_simulation ();
    int stop_simulation ();
    ~c_router ();
};


class c_router_fifo : public c_router
{
  public:
    c_router_fifo(); // deault constructor
    c_router_fifo(int lb, int ub, int st, int p_size, int net_cap, double sd, int qc);    
    int start_simulation();
};


class c_router_epd : public c_router
{
  private:
  int epd_threshold;
  
  public:
    c_router_epd(); // deault constructor
    c_router_epd(int lb, int ub, int st, int p_size, int tepd, int net_cap, double sd, int qc);
    int get_epd_threshold();
    int start_simulation();
};

#endif
