//
// A Multimedia Traffic Simulation
//
// 
// (c) Copyright ensi, 1997.
//
// main header file
//

#ifndef __SIMUL_MAIN_H
#define __SIMUL_MAIN_H

#include <stdlib.h>
#include <stdio.h>
#include <fstream.h>
#include <time.h>	// to set the seed of the generator

  // makes sure the pointer on the object passed as a parameter
  // is not null
#define ASSERT_VALID(ptr) if (ptr==NULL) return 2

#define DEFAULT_PACKET_SIZE       1024
#define DEFAULT_LOWER_BOUND       0
#define DEFAULT_UPPER_BOUND       DEFAULT_PACKET_SIZE * 10 - 1;
#define DEFAULT_SOURCE_THROUGHPUT 25
#define DEFAULT_EPD_THRESHOLD     20
#define DEFAULT_NET_CAPACITY      256000
#define DEFAULT_QUEUE_CAPACITY    40
#define DEFAULT_SIM_DURATION      10

#define POLICY_FIFO               0
#define POLICY_EPD                1
#define DEFAULT_POLICY            POLICY_FIFO

#define EVENT_ARRIVAL             0
#define EVENT_ENTRY               1
#define EVENT_DEPARTURE           2

#define ERR_FILE_SYSTEM 10
#define OK              0
#define DO_NOT_MIND     1

#define FALSE           0
#define TRUE            1

extern double current_date;
extern double sim_duration;

#endif
