//
// A Multimedia Traffic Simulation
//
// 
// (c) Copyright ensi, 1997.
//
// time line class - source file
//


#include "time_line.h"

c_event_container::c_event_container()
{
  link = NULL;
};


c_event_container::~c_event_container()
{
};


c_time_line::c_time_line()
{
  top_events = NULL;
}


int c_time_line::is_empty()
{
  return (top_events == NULL);
}


int c_time_line::insert_event(int e_type, double e_date, c_packet* e_packet)
{
  if (is_empty())
    {
      top_events = new c_event_container;
      top_events->event.set_event_type(e_type);
      top_events->event.set_event_date(e_date);
      top_events->event.set_event_packet(e_packet);
      return OK;
    }

  c_event_container *traveller_ptr = top_events;
  
  if (top_events->event.get_event_date() >= e_date)
    {
      top_events = new c_event_container;
      top_events->event.set_event_type(e_type);
      top_events->event.set_event_date(e_date);
      top_events->event.set_event_packet(e_packet);
      top_events->link = traveller_ptr;
      return OK;
    }
    
  while (traveller_ptr->link != NULL)
    {
      if (traveller_ptr->link->event.get_event_date() < e_date)
      {
        traveller_ptr = traveller_ptr->link;
      }
      else
        break;
    }

  c_event_container *t_ptr = new c_event_container;
  t_ptr->event.set_event_type(e_type);
  t_ptr->event.set_event_date(e_date);
  t_ptr->event.set_event_packet(e_packet);
  t_ptr->link = traveller_ptr->link;
  traveller_ptr->link = t_ptr; 
  return OK;    
}


c_event c_time_line::retrieve_event()
{   
  c_event ret_event;
  c_event_container* tptr = top_events;
  
  ret_event = top_events->event;
  
  top_events = top_events->link;
  delete tptr;
  
  return ret_event;
}


int c_time_line::remove_event(c_event* event)
{
  c_event_container *traveller_ptr;
  c_event_container *tptr;
  if (&(top_events->event) == event)
    {
      traveller_ptr = top_events;
      top_events = top_events->link;
      delete traveller_ptr;
      return OK;
    }
  
  traveller_ptr = top_events;
  while (&(traveller_ptr->link->event) != event)
    {
      traveller_ptr = traveller_ptr->link;
      if (traveller_ptr->link == NULL)
        return DO_NOT_MIND;
    }
    
  tptr = traveller_ptr->link;
  traveller_ptr->link = traveller_ptr->link->link;
  delete tptr;
  return OK;  
}


c_time_line::~c_time_line()
{
}
